
library(miscF)
set.seed(99)

simMixNorm <- function(k,lambda,muRec,varRec,n){
	   res <- numeric(n)
	   for( i in 1:n){
	   	s <- sample(1:k,1,prob=lambda)
	   	res[i] <- rnorm(1, muRec[s], sqrt(varRec[s]))
	   }
	   return(res)
}

Mode <- function(x) {
  ux <- unique(x)
  ux[which.max(tabulate(match(x, ux)))]
}

args <- commandArgs(TRUE)

f.tms <- as.character(args[1])
f.postPred <- as.character(args[2])

dat <- read.table(f.tms)
tms <- dat$V5*100
if(length(tms)>20000){tms1 <-  sample(tms, 20000, replace=FALSE); tms <- tms1}
tms_log <- tms

maxiter <- 30000; burnin <- 20000;
k <- 1; w <- c(1); mu <- c(50); sigma2 <- c(100)
Z <- do.call(cbind, lapply(1:1, function(i) w[i]*dnorm(tms_log,mu[i],sqrt(sigma2[i]))))
Z <- apply(Z, 1, function(x) which(x==max(x))[1])

# 3
k.max <- 115
rst <- uvnm.rjmcmc(tms_log, nsweep=maxiter, w, mu, sigma2, Z,
      k=1, kmax=k.max)

# thin the chain 5
index <- seq(maxiter-burnin, maxiter, 5)
y <- c()
#cat("", file=f.param.allk, sep="")
for(i in index){
     k <- rst$k.save[i]
     w.rec <- rst$w.save[[i]]
     mu.rec <- rst$mu.save[[i]]
     var.rec <- rst$sigma2.save[[i]]
#     cat(c(k, '#' ,mu.rec, '#', var.rec, '#',  w.rec, "\n") , file=f.param.allk, sep=" ", append=T)
     # prediction
     y <- c(y,simMixNorm(k, w.rec, mu.rec, var.rec, 5))
}
y <- y/100	
y <- y[y>0 & y<1	]
y <- sort(as.numeric(y))
#cat(c(0, 1), file=f.postPred, sep="\n")
cat(y,file=f.postPred)	       
