#!/usr/bin/perl

############################
$qFile = "query.TMscore";
$foldDir = "./initialFold";

$cepFile = "$qFile\.cep";
$rstFile = "$qFile\.fold";

############################

if(! -s "$qFile"){ die "Query file is missing: $qFile\n"}	

open(in,"$qFile");
while($l = <in>){
    chomp($l);
    if($l =~ /^(\S+)/){
	@l = split(/\#/,$l);
	$fd = $l[1];$fold{$fd} = $fd;
#2vqeT00#1.20.1260#1tjoB00#0.57970
	$fd_query_tms{$fd}.="$l[0] $l[2] $l[3]\#";
    }
}
close(in);

foreach $fd (keys %fd_query_tms){
    $fdFile = "$foldDir/$fd\-fold.TMscore.sample";
    if(! -s "$fdFile"){die "Fold file is missing: $fdFile";}
    open(tmp,"$fdFile"); @tmp=<tmp>;chomp(@tmp);close(tmp);
    @postDistr = split(/\s+/,$tmp[0]);
    @postDistr = sort {$a<=>$b} @postDistr;

    @qInfo = split(/\#/,$fd_query_tms{$fd});
    foreach $tmp (@qInfo){
	if($tmp =~ /^(\S+)\s+(\S+)\s+(\S+)/){
	    $tms = $3; $query = $1; $target =$2;	    
	}else{
	    die "Wrong format in file: $qFile";
	}
	$cep = &prob_slow(\@postDistr, $tms,5,1);
	$key = "$query\#$fd\#$target\#$tms";
	$key_cep{$key}=$cep;
	if($query_cep{$query}<$cep || $query_cep{$query} !~ /\S+/){
	    $query_cep{$query} = $cep;
	    $query_info{$query} = "$fd $target $cep\n";
	}
    }
}

open(in,"$qFile");
open(out,">$cepFile");
while($l = <in>){
    chomp($l);
    if($l =~ /^(\S+)/){
	print out "$l\#$key_cep{$l}\n";
    }
}
close(in);
close(out);

open(rst,">$rstFile");
foreach $query (keys %query_info){
    print rst "$query $query_info{$query}\n";
}
close(rst);

sub prob{
    my ($f, $tm, $mean, $sd, $part, $top) = @_;
    my @tmp1 = @$f; chomp(@tmp1);
    my $len = @tmp1;
    my $cnt = 0;
    undef @cut;
    undef @point;
    my @cut;
    for(my $c = 1; $c <= ($part-1); $c++){
	my $t = int($len/($part))*$c;
	$cut[$c]=$tmp1[$t];
	$point[$c]=$t;
    }
    $cut[0]=0;
    $point[0]=0;
    push(@cut,$top);
    for(my $c = 0; $c < @cut; $c++){
	my $c1 = $c+1;
	if($tm > $cut[$c] && $tm <= $cut[$c1]){
	    $cnt = $point[$c];
	    goto st;
	}
    }
  st:;
    for(my $t=$cnt; $t<@tmp1; $t++){
	if($tmp1[$t]<=$tm){
	    $cnt++;
	}else{
	    goto endprob1;
	}
    }
  endprob1:;
    my $prob = $cnt/$len;
    $prob = sprintf("%.4f",$prob);
    return ($prob);
}

sub prob_slow{
    my ($f, $tm) = @_;
    my @tmp1 = @$f; chomp(@tmp1);
    my @tmp = sort {$a<=>$b} @tmp1;
    my $len = @tmp;
    my $cnt = 0;
    for(my $t=0; $t<@tmp; $t++){
	if($tmp[$t]<=$tm){
	    $cnt++;
	}else{
	    goto endprob1_slow;
	}
    }
  endprob1_slow:;
    my $prob = $cnt/$len;
    $prob = sprintf("%.4f",$prob);
    return ($prob);
}
